/*******************************************************************************
 * Copyright (c) 2007, 2011 IBM Corp. and others
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution and
 * is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
 *******************************************************************************/
package com.ibm.j9tools.om;

/**
 * Exception used to indicate a {@link BuildSpec}'s JCL configuration is invalid.
 * 
 * @author 	Gabriel Castro
 * @since	v1.5.0
 */
public class InvalidJCLException extends OMElementException {
	private static final long serialVersionUID = 1L;	/** Identifier for serialized instances. */

	/**
	 * Creates an exception with the given error message and object.
	 * 
	 * @param 	message		the error message
	 * @param 	object		the object in which the error was found
	 */
	public InvalidJCLException(String message, OMObject object) {
		super(message, object);
	}
}
